''Modified by RJA to give 1024x600@72Hz WSVGA
'Adjusted pixel clock and horizontal timings by factor of 1024/800=1.28
'Changes "XCONT" to "XZERO" on horizontal line visible section to steady display
{ 
************************************
*                                  *
*    VGA 800 x 600 72Hz 4bpp lut   *
*     + graphics & text support    *
*                                  *
*     Ozpropdev 1st March 2016     *
*                                  *
************************************

Version 2 - Added 16x16 font mode

}

        'flags
        #0, rotated,small

        w = 960'1920/2'1680/2'1920/2'800'1024'800
        h = 540'1080/2'1050/2'1080/2'600
        k = (w/8) * (h/16)      'number of lines per test bars

        sys_clk = 80_000_000

        'color palette names
        #0,black,blue,green,cyan,red,magenta,brown,gray 
        dark_gray,bright_blue,bright_green,bright_cyan 
        bright_red,bright_magenta,Yellow,white 

CON

  intensity     = 80    '0..128

  fclk          = 80_000_000.0
  fpix          = 75_000_000.0'64_000_000.0'50_000_000.0*1024.0/800.0
  fset          = (fpix / fclk * 2.0) * float($4000_0000)

  vsync         =       0       'vsync pin (all FPGA boards now)

DAT             org

                loc     PA,#@gfx      'adra-->PA. launch demo
                coginit #16,PA'adra

DAT ' Display Driver
' Setup
'

'copy color palette to lut ram

                mov     x,#0
                loc     ptrb,#@palette
                rep     @.loop,#16              '16 colors
                rdlong  y,ptrb++
                and     y,##$ffffff00
                wrlut   y,x
                add     x,#1

                'rdfast  ##w*h/128,##@video_buffer       'set rdfast to wrap on bitmap  
.loop

                'rdfast  ##w*h/128,##@video_buffer       'set rdfast to wrap on bitmap

                setxfrq ##$8000_0000'round(fset)           'set transfer frequency to 25MHz

                setb    dira+vsync>>5,#vsync    'make vsync pin output

                'the next 4 lines may be commented out to bypass level scaling

                setcy   ##intensity << 24       'r      set colorspace for rgb
                setci   ##intensity << 16       'g
                setcq   ##intensity << 08       'b
                setcmod #%01_0_000_0            'enable colorspace conversion

                WRPIN dacmode,#0              'enable dac modes in pins 0..3
                WRPIN dacmode,#1
                WRPIN dacmode,#2
                WRPIN dacmode,#3
'
'
' Field loop
'
field           mov     pBuf,##@video_buffer
                mov     x,#36'36'40'37                   'top blanks
                call    #blank

                mov     x,##h                   'set visible lines
line            rdfast  ##w,pBuf       'set rdfast to wrap on bitmap
                call    #hsync                  'do horizontal sync
                xzero   m_rf,#%100        'RJA         'visible line
                rdfast  ##w,pBuf       'set rdfast to wrap on bitmap 
                call    #hsync                  'do horizontal sync
                xzero   m_rf,#%100        'RJA         'visible line
                add     pBuf,#w/2
                  
                djnz    x,#line                 'another line?

                mov     x,#4'4'26'23                   'bottom blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync on

                mov     x,#4'4'2                    'sync blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync off

                jmp     #field                  'loop
'
'
' Subroutines
'
blank           call    #hsync                  'blank lines
                'xcont   m_vi,#0
                xzero   m_vi,#0          'RJA
                djnz    x,#blank
                ret

hsync           xcont   m_bs,#0                 'horizontal sync
                xcont   m_sn,#1
                xcont   m_bv,#0
                ret
'
'
' Initialized data
'
dacmode         long    %0000_0000_000_1010000000000_01_00000_0  'RJA: New! %101<<29 + %10100<<8

'm_bs            long    $CF000000+56*1024/800             'before sync
'm_sn            long    $CF000000+120*1024/800            'sync
'm_bv            long    $CF000000+64*1024/800             'before visible

m_bs            long    $CF000000+188'66'*1024/800             'before sync
m_sn            long    $CF000000+84'120'*1024/800            'sync
m_bv            long    $CF000000+78 'te80'64'*1024/800             'before visible
m_vi            long    $CF000000+w             'visible
m_rf            long    $6F000000+w             '4bit RFLONG LUT

x               res     1
y               res     1
pBuf            res     1

'====================================================================

                orgh    $400

DAT 'palette
'24 but color format = rr_gg_bb_00

palette
                long    0               'black 
                long    $0000aa00       'blue 
                long    $00aa0000       'green 
                long    $00aaaa00       'cyan 
                long    $aa000000       'red 
                long    $aa00aa00       'magenta 
                long    $aa550000       'brown 
                long    $aaaaaa00       'gray 
                long    $55555500       'dark gray 
                long    $5555ff00       'bright blue 
                long    $55ff5500       'bright green 
                long    $55ffff00       'bright cyan 
                long    $ff555500       'bright red 
                long    $ff55ff00       'bright magenta 
                long    $ffff5500       'Yellow 
                long    $ffffff00       'white 


'====================================================================

DAT 'Graphics demo

                org

gfx             jmp     #demo           'launch hubexec code

'******************************
'*  Basic graphics functions  *
'******************************

'Clear screen (fills with current color)

cls             mov     temp,color
                setnib  temp,color,#1
                setbyts temp,temp
                loc     ptra,#@video_buffer     '#$1000
                rep     @.cls,##w*h/8
                wrlong  temp,ptra++
.cls


DAT 'Set pixel @ x1,y1 with current color

set_pixel       cmp     x1,##w-1 wz,wc          'boundary check
        if_a    ret
                cmp     y1,##h-1 wz,wc
        if_a    ret
                testb   x1,#31 wc
        if_c    ret
                testb   y1,#31 wc
        if_c    ret

                'RJA:  Note that nice thing about w=1024 is that multiply is just a shift, don't need this cordic
                mov     ptra,y1
                'shl     ptra,#9 'For 1024 can shift instead of multiply
                qmul    ptra,##w/2'RJA 800 / 2          '2 pixels per byte
                getrnd  ptra   'RJA:  What does this do Stalling?
                getqx   ptra
                mov     .temp,x1
                shr     .temp,#1
                add     ptra,.temp
                add     ptra,##@video_buffer    '$1000
                rdbyte  .temp,ptra
                testb   x1,#0 wc
        if_c   setnib  .temp,color,#0
        if_nc    setnib  .temp,color,#1
                wrbyte  .temp,ptra
.loop
                ret     wz,wc

.temp           long    0



DAT 'Plot line
' Plot line from px,py to dx,dy     (from graphics.spin)
' RJA:  Replaced line draw code with that of P1's graphics.spin
'plot line from x1,y1 to x2,y2 in current color
'one difference is that need to restore x1,y1 before exiting

plot_line
                        'First, form px,py and dx,dy
                        mov     dx,x2
                        mov     dy,y2
                        mov     px,x1
                        mov     py,y1
                        
                        'cmps    dx,x1           wc', wr  'get x difference
                        subs    dx,x1          'P2 version of above
                        negc    asx,#1                   'set x direction

                        'cmps    dy,y1           wc', wr  'get y difference
                        subs    dy,y1           'P2 version of above
                        negc    asy,#1                   'set y direction

                        abs     dx,dx                   'make differences absolute
                        abs     dy,dy

                        cmp     dx,dy           wc      'determine dominant axis
        if_nc           tjz     dx,#.last               'if both differences 0, plot single pixel
        if_nc           mov     count,dx                'set pixel count
        if_c            mov     count,dy
                        mov     ratio,count             'set initial ratio
                        shr     ratio,#1
        if_c            jmp     #.yloop                 'x or y dominant?


.xloop                  call    #set_pixel                   'dominant x line
                        add     x1,asx
                        sub     ratio,dy        wc
        if_c            add     ratio,dx
        if_c            add     y1,asy
                        djnz    count,#.xloop

                        jmp     #.last                  'plot last pixel


.yloop                  call    #set_pixel                  'dominant y line
                        add     y1,asy
                        sub     ratio,dx        wc
        if_c            add     ratio,dy
        if_c            add     x1,asx
                        djnz    count,#.yloop

.last                   call    #set_pixel                   'plot last pixel

linepd_ret              ret

'count   long 0
ratio   long 0
asx     long 0
asy     long 0
dx      long 0
dy      long 0
px      long 0
py      long 0



{   'Replacing line draw with Chip's code (above) 
'plot line from x1,y1 to x2,y2 in current color

plot_line       push    x1
                push    y1
                mov     x1,x2
                mov     y1,y2
                call    #set_pixel
                pop     y1
                pop     x1
                mov     x_inc,#1
                mov     y_inc,#1
                mov     PA,x2
                sub     PA,x1 wc
                negc    x_inc
                abs     width,PA              'get width
                mov     PB,y2
                sub     PB,y1 wc
                negc    y_inc
                abs     height,PB             'get height
                cmp     width,height wz,wc
        if_b    jmp     #pl2
'x > y
                qmul    height,_1000
                mov     temp2,#0
                push    x1
                push    y1
                getqx   temp
                qdiv    temp,width
                getqx   temp
.pl1            call    #set_pixel
                add     x1,x_inc
                add     temp2,temp
                cmp     temp2,_1000 wz,wc
        if_a    add     y1,y_inc
        if_a    sub     temp2,_1000
                djnz    width,#.pl1
                pop     y1
                pop     x1
                ret
'y > x
pl2
                qmul    width,_1000
                mov     temp2,#0
                push    x1
                push    y1
                getqx   temp
                qdiv    temp,height
                getqx   temp
.pl2a           call    #set_pixel
                add     y1,y_inc
                add     temp2,temp
                cmp     temp2,_1000 wz,wc
        if_a    add     x1,x_inc
        if_a    sub     temp2,_1000
                djnz    height,#.pl2a
                pop     y1
                pop     x1
                ret
}                

DAT'plot circle centred at x1,y1 using radius,start_angle,sweep, resolution
'
plot_circle     qfrac   start_angle,#360
                getqx   angle
                qfrac   resolution,##3600       '10 = 1 deg
                getqx   temp
                mov     cc,sweep
                mul     cc,#10
                qdiv    cc,resolution
                getqx   cc
.loop           qrotate radius,angle
                push    x1
                push    y1
                getqx   x9
                getqy   y9
                add     x1,x9
                add     y1,y9
                call    #set_pixel
                pop     y1
                pop     x1
                add     angle,temp
                djnz    cc,#.loop
                ret

DAT'draw box top left corner x1,y1 to bottom right x2,y2 in current color

plot_box        mov     x1a,x1
                mov     y1a,y1
                mov     x2a,x2
                mov     y2a,y2

                mov     y2,y1           'top
                call    #plot_line
                
                mov     x1,x1a
                mov     y1,y2a
                mov     x2,x2a
                mov     y2,y2a
                call    #plot_line      'bottom

                mov     x1,x1a
                mov     y1,y1a
                mov     x2,x1
                mov     y2,y2a
                call    #plot_line      'left

                mov     x1,x2a
                mov     y1,y1a
                mov     x2,x1
                mov     y2,y2a
                call    #plot_line      'right

                mov     x1,x1a
                mov     y1,y1a
                mov     x2,x2a
                mov     y2,y2a

                ret

DAT'plot character @ x1,y1 using forecolor,backcolor
'if bit #0 of "flags" is set , text will be rotated left

plot_char       testb   flags,#small wc
        if_c    mov     font_h,#16
        if_nc   mov     font_h,#32      
                loc     ptrb,#@font
                testb   ascii,#0 wz
                clrb    ascii,#0
                shl     ascii,#6
                add     ptrb,ascii
                mov     count2,font_h   '#32

.loop2          rdlong  bits,ptrb++
                testb   flags,#small wc
        if_c    rdlong  bits2,ptrb++
        if_c    or      bits,bits2
        if_nz   shr     bits,#1
                mov     count,#16
.loop           testb   bits,#0 wc
        if_c    mov     color,forecolor
        if_nc   mov     color,backcolor
                call    #set_pixel
                shr     bits,#2
                testb   flags,#rotated wc
        if_nc   add     x1,#1
        if_c    sub     y1,#1
                djnz    count,#.loop
                testb   flags,#rotated wc
        if_nc   sub     x1,#16
        if_nc   add     y1,#1
        if_c    add     y1,#16
        if_c    add     x1,#1
                djnz    count2,#.loop2
                testb   flags,#rotated wc
        if_nc   sub     y1,font_h       '#32
        if_nc   add     x1,#16
        if_c    sub     x1,font_h       '#32
        if_c    sub     y1,#16
                ret     wz,wc

font_h          long    0
flags           long    0
ascii           long    0
count2          long    0
forecolor       long    white
backcolor       long    0
bits            long    0
bits2           long    0

DAT'plot zero terminated string @ptrb  to x1,y1

plot_string     rdbyte  ascii,ptrb wz
        if_z    ret wz,wc
                push    ptrb
                call    #plot_char
                pop     ptrb
                add     ptrb,#1
                jmp     #plot_string

'plot value as hex string @ x1,y1
'entry at plot_hex_d assumes digits set by user

plot_hex        mov     digits,#8
plot_hex_d      mov     temp3,digits
                subr    temp3,#8
                shl     temp3,#2
                rol     value,temp3
.loop           getnib  ascii,value,#7
                cmp     ascii,#9 wz,wc
        if_be   add     ascii,#"0"
        if_a    add     ascii,#"A"-10
                call    #plot_char
                rol     value,#4
                djnz    digits,#.loop
                ret

digits          long    0
value           long    0

'plot signed/unsigned decimal string @ x1,y1

plot_dec_s      testb   value,#31 wc
        if_nc   mov     ascii,#"+"
        if_c    mov     ascii,#"-"
                call    #plot_char
                negc    value

plot_dec        mov     r1,##1_000_000_000
                mov     r3,#0
                rep     @.sd2,#10
                qdiv    value,r1
                getqx   temp
                getqy   value
                rolnib  r4,r3,#7
                rolnib  r3,temp,#0
                qdiv    r1,#10
                getqx   r1
.sd2            
                mov     digits,#2
                mov     value,r4
                call    #plot_hex_d
                mov     value,r3
                call    #plot_hex
                ret

r1              long    0
r2              long    0
r3              long    0
r4              long    0

'Assorted working registers

x1a             long    0
y1a             long    0
x2a             long    0
y2a             long    0

resolution      long    0
start_angle     long    0
sweep           long    0
x9              long    0
y9              long    0
cc              long    0
angle           long    0
radius          long    0
temp3           long    0


_1000           long    1_000
width           long    0
height          long    0
x_inc           long    0
y_inc           long    0
count           long    0
temp            long    0
temp2           long    0
x1              long    0
y1              long    0
x2              long    0
y2              long    0
color           long    0

'====================================================================

                orgh
msg             byte    "VGA 800x600 Graphics & text",0
msg2            byte    "Parallax Propeller 2 FPGA",0
msg3            byte    "Rotated text",0


'====================================================================

DAT'Hub exec code

                orgh
demo            waitx   ##sys_clk * 1'5

 ''RJA Testing

                call    #ShowEmbeddedBmp
 
                mov     x1,##0'+200
                mov     x2,##w-1'-200
                mov     y1,##0'+200
                mov     y2,##h-1'-200
                getrnd  color
                'call    #plot_box





                
.testing
                jmp     #.testing



'show 16 x color stripes

demo_loop       loc     ptrb,#@video_buffer
                mov     PA,#16
                mov     PB,#0 '#$11111111
.loop2          rep     @.loop,##k
                wrlong  PB,ptrb++
.loop
                add     PB,##$11111111
                djnz    PA,#.loop2

                waitx   ##sys_clk * 1'3

                                

'shrinking box in random color **********************************

sb              mov     x1,##0
                mov     y1,##0
                mov     x2,##w-1
                mov     y2,##h-1
                mov     temp3,#300
                getrnd  color

.loop           call    #plot_box
                add     x1,#1
                sub     x2,#1
                add     y1,#1
                sub     y2,#1
                waitx   ##1000000
                djnz    temp3,#.loop


'circular pattern  ***********************************************

cp              mov     x1,#400
                mov     y1,#300
                mov     radius,#50
                mov     start_angle,#15
                mov     sweep,#330
                mov     resolution,#5           '10 = 1 deg steps

                getnib  temp3,color,#0
.same           getrnd  color
                and     color,#$f
                cmp     color,temp3 wz,wc
        if_e    jmp     #.same

                mov     count,#250
.loop           call    #plot_circle
                add     radius,#1
                djnz    count,#.loop

                waitx   ##sys_clk * 3


'random colored lines  ********************************************

                mov     x1,#0
                mov     y1,#0
                getrnd  color
                call    #cls
                mov     temp3,#500

again           getrnd  color
                getrnd  PA
                getword x2,PA,#0
                and     x2,##$3ff
                cmp     x2,##w-1 wz,wc
        if_a    jmp     #again
                getword y2,PA,#1
                and     y2,##$3ff
                cmp     y2,##h-1 wz,wc
        if_a    jmp     #again

                call    #plot_line
                mov     x1,x2
                mov     y1,y2
                djnz    temp3,#again

                waitx   ##sys_clk * 3

'text test  *******************************************************

                clrb    flags,#rotated
                clrb    flags,#small

                mov     x1,#100
                mov     y1,#100
                getrnd  forecolor
                getnib  backcolor,forecolor,#5
                loc     ptrb,#@msg
                call    #plot_string

                mov     x1,#100
                mov     y1,#200
                getrnd  forecolor
                getnib  backcolor,forecolor,#5
                loc     PB,#@msg2
                call    #plot_string

                setb    flags,#rotated  'rotate text
                mov     x1,#40
                mov     y1,#500
                mov     forecolor,#yellow
                mov     backcolor,#black
                loc     PB,#@msg3
                call    #plot_string

                clrb    flags,#rotated
                setb    flags,#small

                mov     x1,##650
                mov     y1,#400
                mov     value,##$c0ffee
                mov     forecolor,#green
                call    #plot_hex

                mov     x1,##650
                mov     y1,#440
                mov     digits,#6
                mov     value,##$c0ffee
                mov     forecolor,#green
                call    #plot_hex_d

                mov     x1,##350        'show unsigned decimal
                mov     y1,#300
                mov     digits,#6
                mov     value,##-1
                mov     forecolor,#bright_blue
                call    #plot_dec

                mov     x1,##350        'show signed decimal
                mov     y1,##340
                mov     digits,#6
                mov     value,##-1
                mov     forecolor,#bright_green
                call    #plot_dec_s

                waitx   ##sys_clk * 5

'show all characters in 16x16 mode  **************************

sac             setb    flags,#small

                mov     x1,#0
                mov     y1,#0
                mov     r1,#0
                mov     r3,#37  '18
                mov     forecolor,#black
.loop2          mov     r2,#50

.loop           mov     ascii,r1
                incmod  r1,#255
                getrnd  backcolor
                and     backcolor,#$f wz
        if_z    mov     backcolor,#white
                call    #plot_char
                djnz    r2,#.loop
                mov     x1,#0
                add     y1,#16  '32
                djnz    r3,#.loop2

                waitx   ##sys_clk * 5

'show all characters in 16x32 mode  **************************

sac2            clrb    flags,#small

                mov     x1,#0
                mov     y1,#0
                mov     r1,#0
                mov     r3,#18
                mov     forecolor,#black
.loop2          mov     r2,#50

.loop           mov     ascii,r1
                incmod  r1,#255
                getrnd  backcolor
                and     backcolor,#$f wz
        if_z    mov     backcolor,#white
                call    #plot_char
                djnz    r2,#.loop
                mov     x1,#0
                add     y1,#32
                djnz    r3,#.loop2

                waitx   ##sys_clk * 5


'show all 16x16 characters rotated   ********************************

sac_rotated     setb    flags,#small
                setb    flags,#rotated

                mov     x1,#0
                mov     y1,##592
                mov     r1,#0
                mov     r3,#50 '25
                mov     backcolor,#black
.loop2          mov     r2,#37

.loop           mov     ascii,r1
                incmod  r1,#255
                getrnd  forecolor
                and     forecolor,#$f wz
        if_z    mov     forecolor,#white
                call    #plot_char
                djnz    r2,#.loop
                add     x1,#16  '32
                mov     y1,##592
                djnz    r3,#.loop2

                waitx   ##sys_clk * 5

'show all 16x16 characters rotated   ********************************

sac_rotated2    clrb    flags,#small
                setb    flags,#rotated

                mov     x1,#0
                mov     y1,##592
                mov     r1,#0
                mov     r3,#25
                mov     backcolor,#black
.loop2          mov     r2,#37

.loop           mov     ascii,r1
                incmod  r1,#255
                getrnd  forecolor
                and     forecolor,#$f wz
        if_z    mov     forecolor,#white
                call    #plot_char
                djnz    r2,#.loop
                add     x1,#32
                mov     y1,##592
                djnz    r3,#.loop2

                clrb    flags,#small
                clrb    flags,#rotated

                waitx   ##sys_clk * 5
                jmp     #demo_loop

DAT   'ShowEmbeddedBmp Show embedded bmp
ShowEmbeddedBmp
{
'analyze and prepare bitmap image for display on TV
  bytemove(@bfType,p,2) 'read bmp header
  p+=2
  bytemove(@bfSize,p,4) 'read bmp header
  p+=4
  bytemove(@bfReserved1,p,4) 'read bmp header
  p+=4
  bytemove(@bfOffBits,p,16) 'read bmp header
  p+=16
  bytemove(@biPlanes,p,4)
  p+=4
  bytemove(@biCompression,p,24)
  p+=24
  'calculate actual bytes in palette
  i:=bfOffBits-54
  'read in palette
  'bytemove(@BmpPalette,p,i)  'Note:  Don't need palette since using our own colors
  p+=i
}

                mov     x1,##0+200
                mov     x2,##1023-200
                mov     y1,##0+200
                mov     y2,##599-200
                getrnd  color
                'call    #plot_box
                'ret

              loc       ptrb,#@video_buffer
              loc       ptra,#@FontBmp

              add       ptra,#118 'Know that pixels start with a byte offset (62 for 1-bit, 118 for 4bit)

              add       ptrb,##(bmph*w/2) 'BMP data upside down, so start at bottom
              
              mov       y1,#bmph        
.loop2        mov       x1,#bmpw/8
.loop         rdlong    r1,ptra++
              'mov       r1,#$FF
              
              wrlong    r1,ptrb++
              djnz      x1,#.loop
              sub       ptrb,##(w+bmpw)/2
              djnz      y1,#.loop2            




              ret

con
  bmpw=256'128'256
  bmph=128'256'128              

DAT     'Header space for processing bitmap files
ALIGNL
BMPHeader  byte 'Mostly using info from here:  http://www.fortunecity.com/skyscraper/windows/364/bmpffrmt.html
bfType byte "B","M"  
bfSize long 0
bfReserved1 word 0
bfReserved2 word 0
bfOffBits long 54
biSize long 40
biWidth long 0
biHeight long 10
biPlanes word 1
biBitCount word 24
biCompression long 0
biSizeImage long 0
biXPelsPerMeter long 0
biYPelsPerMeter long 0
biClrUsed long 0
biClrImportant long 0              
{
'analyze and prepare bitmap image for display on TV
  bytemove(@bfType,p,2) 'read bmp header
  p+=2
  bytemove(@bfSize,p,4) 'read bmp header
  p+=4
  bytemove(@bfReserved1,p,4) 'read bmp header
  p+=4
  bytemove(@bfOffBits,p,16) 'read bmp header
  p+=16
  bytemove(@biPlanes,p,4)
  p+=4
  bytemove(@biCompression,p,24)
  p+=24
  'calculate actual bytes in palette
  i:=bfOffBits-54
  'read in palette
  'bytemove(@BmpPalette,p,i)  'Note:  Don't need palette since using our own colors
  p+=i
}

'====================================================================
'orgh            $8000  'RJA
ALIGNL
video_buffer    byte    $11[w * (h-1) / 2]
              byte    $FF[w * 1 / 2]   
              byte      0[w*2]

font            file "p1_font.dat"

DAT   'The embedded font
ALIGNL
FontBmp byte
        file "ProgoCo4bit.bmp"
        'file "ProgoCo4bitRot.bmp" 